package com.odhen.taa;

public class ErrorMessages {

    public String getErrorMessageFromStatus(int status) {
        String message;

        if(status > 0) {
            message = "Transação negada pelo autorizador.";
        } else {
            switch(status) {
                case -1:
                    message = "Módulo não inicializado.";
                    break;
                case -2:
                    message = "Operação cancelada pelo operador.";
                    break;
                case -3:
                    message = "O parãmetro / função / modalidade é inexistente/inválido.";
                    break;
                case -4:
                    message = "Falta de memória no PDV.";
                    break;
                case -5:
                    message = "Sem conexão SiTef.";
                    break;
                case -6:
                    message = "Operação cancelada pelo usuário.";
                    break;
                case -7:
                case -42:
                    message = "Reservado (" + status + ").";
                    break;
                case -8:
                    message = "A CliSiTef não possui a implementação da função necessária, provavelmente está desatualizada.";
                    break;
                case -9:
                    message = "A automação chamou a rotina ContinuaFuncaoSiTefInterativo sem antes iniciar uma função iterativa.";
                    break;
                case -10:
                    message = "Algum parâmetro obrigatório não foi passado pela automação comercial.";
                    break;
                case -12:
                    message = "Erro na execução da rotina iterativa.";
                    break;
                case -13:
                    message = "Documento fiscal não encontrado nos registros da CliSiTef.";
                    break;
                case -15:
                    message = "Operação cancelada pela automação comercial.";
                    break;
                case -20:
                    message = "Parâmetro inválido passado para a função.";
                    break;
                case -21:
                    message = "Utilizada uma palavra proibida.";
                    break;
                case -25:
                    message = "Erro no Correspondente Bancário: Deve realizar sangria.";
                    break;
                case -30:
                    message = "Erro de acesso ao arquivo.";
                    break;
                case -40:
                    message = "Transação negada pelo SiTef.";
                    break;
                case -41:
                    message = "Dados inválidos.";
                    break;
                case -43:
                    message = "Problema na execução de alguma das rotinas no pinpad.";
                    break;
                case -50:
                    message = "Transação não segura.";
                    break;
                case -100:
                    message = "Erro interno do módulo.";
                    break;
                case -500:
                    message = "Erro na execução da Thread.";
                    break;
                case -501:
                    message = "Transação não finalizada. É necessário refazê-la.";
                    break;
                default:
                    message = "Transação negada.";
                    break;
            }
        }

        return message;
    }
}
