package com.odhen.taa;

import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

public class PaymentData {
    private String TAG = "|SitefIntegration| ";

    private int paymentType;
    private String paymentValue;
    private String paymentInvoice;
    private String paymentIp;
    private String paymentStore;
    private String paymentTerminal;
    private String paymentDate;
    private String paymentHour;
    private String storeCnpj;
    private String paymentOperator;
    private String tlsType;
    private String tlsNumber;
    private String paymentNSU;
    private String paymentAuth;
    private String paymentVia;

    public PaymentData(JSONObject data) throws JSONException {
        this.paymentIp       = data.get("endSitef").toString();
        this.paymentStore    = data.get("storeId").toString();
        this.paymentTerminal = data.get("terminalId").toString();
        if (data.has("CNPJLoja")) {
            this.storeCnpj = data.get("CNPJLoja").toString();
        }
    }

    public int getPaymentType() {
        return paymentType;
    }

    public void updatePaymentDataWithStart(JSONObject data) throws JSONException {
        this.paymentType = Integer.parseInt(data.get("startFunction").toString());
        this.paymentValue = data.get("value").toString();
        this.paymentInvoice = data.get("text").toString();
        this.paymentDate = data.get("date").toString();
        this.paymentHour = data.get("time").toString();
        this.paymentOperator = data.get("operator").toString();
    }

    public void setPaymentType(int paymentType, JSONObject data) {
        this.paymentType = paymentType;
        try{
            switch(paymentType) {
                case 2:
                    Log.d(TAG, "IDTIPORECE: 2");
                    data.put("IDTIPORECE", "2");
                    break;
                case 122:
                    Log.d(TAG, "IDTIPORECE: H");
                    data.put("IDTIPORECE", "H");
                    break;
                default:
                    Log.d(TAG, "IDTIPORECE: 1");
                    data.put("IDTIPORECE", "1");
                    break;
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getPaymentValue() {
        return paymentValue;
    }

    public void setPaymentValue(String paymentValue) {
        this.paymentValue = paymentValue;
    }

    public String getPaymentInvoice() {
        return paymentInvoice;
    }

    public void setPaymentInvoice(String paymentInvoice) {
        this.paymentInvoice = paymentInvoice;
    }

    public String getPaymentIp() {
        return paymentIp;
    }

    public void setPaymentIp(String paymentIp) {
        this.paymentIp = paymentIp;
    }

    public String getPaymentStore() {
        return paymentStore;
    }

    public void setPaymentStore(String paymentStore) {
        this.paymentStore = paymentStore;
    }

    public String getPaymentTerminal() {
        return paymentTerminal;
    }

    public void setPaymentTerminal(String paymentTerminal) {
        this.paymentTerminal = paymentTerminal;
    }

    public String getPaymentDate() {
        return paymentDate;
    }

    public void setPaymentDate(String paymentDate) {
        this.paymentDate = paymentDate;
    }

    public String getPaymentHour() {
        return paymentHour;
    }

    public void setPaymentHour(String paymentHour) {
        this.paymentHour = paymentHour;
    }

    public String getStoreCnpj() {
        return storeCnpj;
    }

    public void setStoreCnpj(String storeCnpj) {
        this.storeCnpj = storeCnpj;
    }

    public String getPaymentOperator() {
        return paymentOperator;
    }

    public void setPaymentOperator(String paymentOperator) {
        this.paymentOperator = paymentOperator;
    }

    public String getTlsType() {
        return tlsType;
    }

    public void setTlsType(String tlsType) {
        this.tlsType = tlsType;
    }

    public String getTlsNumber() {
        return tlsNumber;
    }

    public void setTlsNumber(String tlsNumber) {
        this.tlsNumber = tlsNumber;
    }

    public String getPaymentNSU() {
        return paymentNSU;
    }

    public void setPaymentNSU(String paymentNSU) {
        this.paymentNSU = paymentNSU;
    }

    public String getPaymentAuth() {
        return paymentAuth;
    }

    public void setPaymentAuth(String paymentAuth) {
        this.paymentAuth = paymentAuth;
    }

    public String getPaymentVia() {
        return paymentVia;
    }

    public void setPaymentVia(String paymentVia) {
        this.paymentVia = paymentVia;
    }

   public String getParams() throws JSONException {
       String paymentParameters = "[TipoPinPad=ANDROID_AUTO;";
        if (storeCnpj != null) {
            paymentParameters += "ParmsClient=1=" + storeCnpj + ";2=26269316000177";
        }
       paymentParameters += "]";

        return paymentParameters;
    }
}
