package com.odhen.taa;

import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.webkit.JavascriptInterface;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import br.com.daruma.framework.mobile.DarumaMobile;
import br.com.itfast.tectoy.TecToy;

public class PrinterIntegration extends AppCompatActivity {
    Context mContext;
    private String TAG = "|DarumaMobileIntegration| ";

    private DarumaMobile dmf;
    private TecToy objTecToy;
    int iRet = 0;
    char[] resposta = new char[50];
    char[] registroSAT = new char[200];
    int numDocs = 0;

    ///Formatações de texto
    String centro = "" + ((char) 0x1B) + ((char) 0x61) + ((char) 0x31);
    String deslCentro = "" + ((char) 0x1B) + ((char) 0x61) + ((char) 0x30);
    String direita = "" + ((char) 0x1B) + ((char) 0x61) + ((char) 0x32);
    String deslDireita = "" + ((char) 0x1B) + ((char) 0x61) + ((char) 0x30);
    String extra = "" + ((char) 0x1B) + ((char) 0x21) + ((char) 0x16);
    String deslExtra = "" + ((char) 0x1B) + ((char) 0x21) + ((char) 0x00);
    String negrito = "" + ((char) 0x1B) + ((char) 0x45) + ((char) 0x31);
    String deslNegrito = "" + ((char) 0x1B) + ((char) 0x45) + ((char) 0x30);
    String invetImp = "" + ((char) 0x1D) + ((char) 0x42) + ((char) 0x31);
    String desligInvert = "" + ((char) 0x1D) + ((char) 0x42) + ((char) 0x30);

    String strAux; ///msg de retorno
    String cmdHead;
    String qrcode;

    char strCod[] = new char[5];
    char strmsg[] = new char[1024];


    /**
     * Instantiate the interface and set the context
     */
    PrinterIntegration(Context c) {
        mContext = c;
    }

    // Define a method to show a toast message
    @JavascriptInterface
    public void showPrinterToast(String message) {
        Toast.makeText(mContext, message, Toast.LENGTH_SHORT).show();
    }

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    protected static char[] maiorMenorByte(String dados) {
        char[] retorno = new char[2];

        // Calcula byte mais e menos significativos somando 2 ao tamanho da
        // string pois tambem contamos os bytes da correcao e largura do modulo

        // Calculo do byte mais significativo
        // Se o valor do calculo for igual a 0, entao colocamos o inteiro 0. Se
        // colocar como NULL direto da erro na hora de fazer a concatenacao das
        // variaveis
        if (((dados.length() + 3) >> 8) == 0) {
            retorno[0] = 0;
        } else {
            retorno[0] = (char) ((dados.length() + 3) >> 8);
        }

        // Calculo do byte menos significativo
        // Se o valor do calculo for igual a 0, entao colocamos o inteiro 0. Se
        // colocar como NULL direto da erro na hora de fazer a concatenacao das
        // variaveis
        if (((dados.length() + 3) & 0x00ff) == 0) {
            retorno[1] = 0;
        } else {
            retorno[1] = (char) ((dados.length() + 3) & 0x00ff);
        }

        return retorno;
    }

    protected String gerarQrCode(String texto) {
        StringBuffer strBufferImpressao = new StringBuffer();
        String tamanhoModulo = "" + ((char) 0x1D) + "" + ((char) 0x28) + "" + ((char) 0x6B) + "" + ((char) 0x03) + "" + ((char) 0x00)
                + "" + ((char) 0x31) + "" + ((char) 0x43) + "" + ((char) 0x04);
        strBufferImpressao.append(tamanhoModulo);

        String nivelCorrecao = "" + ((char) 0x1D) + "" + ((char) 0x28) + "" + ((char) 0x6B) + "" + ((char) 0x03) + "" + ((char) 0x00)
                + "" + ((char) 0x31) + "" + ((char) 0x45) + "" + ((char) 0x31);
        strBufferImpressao.append(nivelCorrecao);

        char[] retMenosMais = maiorMenorByte(texto);
        String byteMenosMais = "" + ((char) 0x1D) + "" + ((char) 0x28) + "" + ((char) 0x6B) + "" + ((char) retMenosMais[1]) + "" + ((char) retMenosMais[0])
                + "" + ((char) 0x31) + "" + ((char) 0x50) + "" + ((char) 0x30) + texto;
        strBufferImpressao.append(byteMenosMais);

        String imprimeQrCode = "" + ((char) 0x1D) + "" + ((char) 0x28) + "" + ((char) 0x6B) + "" + ((char) 0x03) + "" + ((char) 0x00)
                + "" + ((char) 0x31) + "" + ((char) 0x51) + "" + ((char) 0x30);
        strBufferImpressao.append(imprimeQrCode);
        return strBufferImpressao.toString();
    }

    @JavascriptInterface
    public void printText(String print) {
        try {
            dmf = DarumaMobile.inicializar(mContext,"@FRAMEWORK(TRATAEXCECAO=TRUE;SATNATIVO=FALSE);@BLUETOOTH(ADDRESS=00:11:22:33:44:55;ATTEMPTS=100;TIMEOUT=10000)");
            dmf.iniciarComunicacao();

//            JSONObject printObj = new JSONObject("{ 'printerInfo': { 'printerType': '16', 'kioskPort': 0, 'port': 'USB' }, 'commands': [ { 'name': 'text', 'parameters': { 'text': '     ODHEN INTEGRACOES CNPJ:\n 71153092000198 ETR DO MONTEIRO,\n    1000,  BARRO PRETO,  BELO\n         HORIZONTE - MG\n--------------------------------\n   DOCUMENTO AUXILIAR DA NOTA\n FISCAL DE CONSUMIDOR ELETRONICA\n--------------------------------\n   Item | Codigo | Descricao |\n  Qtde | UN | Vl.Unit | Vl.Tot\n', 'italic': 0, 'underlined': 0, 'expanded': 0, 'bold': 0, 'letterType': 1 } }, { 'name': 'text', 'parameters': { 'text': '001 9100501000 NOTA FISCAL\nEMITIDA EM AMBIENTE DE\nHOMOLOGACAO - SEM VALOR FISCAL\n1,00 UN 17,80 17,80 \n\n002 9100501001 PIZZA PORTUGUESA\nP 1,00 UN 17,80 17,80 \n\n003 9100501002 PIZZA DE FRANGO\nC CATUPIRY P 1,00 UN 18,80\n18,80 \n\n--------------------------------\nQTDE. TOTAL DE ITENS           3\nVALOR TOTAL R$             54,40\nVALOR A PAGAR R$           54,40\nVALOR PAGO R$              54,40\nFORMA PAGAMENTO CARTEIRA DIGITAL DEV\n--------------------------------\n  Consulte pela Chave de Acesso\n               em\n                \nhttps://hportalsped.fazenda.mg.gov.br/portalnfce\n\n  3123 0571 1530 9200 0198 6535\n    2000 0021 9517 4554 5320 \n--------------------------------\n   CONSUMIDOR NAO IDENTIFICADO\n--------------------------------\n        Numero 000002195\n  Emissao 04/05/2023 16:05:48 -\n         Via Consumidor\n\n    Protocolo de Autorizacao\n         131230027486820\n Data de Autorizacao 04/05/2023\n            16:05:32\n--------------------------------\n\n', 'italic': 0, 'underlined': 0, 'expanded': 0, 'bold': 0, 'letterType': 1 } }, { 'name': 'qrCode', 'parameters': { 'text': 'https://portalsped.fazenda.mg.gov.br/portalnfce/sistema/qrcode.xhtml?p=31230571153092000198653520000021951745545320|2|2|1|CD40603F2B3582EA79ECB6D3F5DC65032ADDA0EC', 'italic': 0, 'underlined': 0, 'expanded': 0, 'bold': 0, 'letterType': 1 } }, { 'name': 'text', 'parameters': { 'text': '\n--------------------------------\n Informacao dos Tributos Totais\n           Incidentes\n  (Lei Federal 12.741/2012) R$\n              1,98\n--------------------------------\n       Teknisa Software -\n         www.teknisa.com\n--------------------------------\n           SENHA 7977\n--------------------------------\nNSU 00000000000005040013\nFilial: 0001 ODHEN INTEGRACOES\nLoja: 01 ODHEN INTEGRACOES\nCaixa: 002 TAA\n\n\n\n\n\n', 'italic': 0, 'underlined': 0, 'expanded': 0, 'bold': 0, 'letterType': 1 } }, { 'name': 'cutPaper', 'parameters': [] } ] }");
            JSONObject printObj = new JSONObject(print);
            JSONArray commands = printObj.getJSONArray("commands");
            System.out.println(commands);

            for (int i = 0; i < commands.length(); i++) {
                JSONObject curCommand = commands.getJSONObject(i);
                Object parameters = curCommand.get("parameters");

                if (parameters instanceof JSONObject) {
                    JSONObject curParameter = (JSONObject) parameters;
                    String curText = curParameter.getString("text");
                    if (curCommand.getString("name").equals("qrCode")) {
                        dmf.enviarComando(centro + gerarQrCode(curText) + deslCentro);
                    } else {
                        dmf.enviarComando(deslCentro + curText);
                    }
                }
            }

            dmf.fecharComunicacao();

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

}